<!--
    <author email="tom@infoether.org">Tom Copeland</author>
-->

# PMD in the press

## Sites/Articles about PMD

*   February 2012 - Romain Pelisse's lightning talk at FOSDEM 2012 about "PMD5: What can it do for you?".
    [Video recording is available](http://video.fosdem.org/2012/lightningtalks/PMD5.webm).

*   May 2008 - Alan Berg's article on
    [Free Software Magazine](http://www.freesoftwaremagazine.com/columns/destroy_annoying_bugs_part_1)
    discusses FindBugs, PMD, and TFTP.

*   July 2007 - Ryan Slobojan's article on [InfoQ](http://www.infoq.com/news/2007/07/pmd)
    discusses the PMD 4.0 release.

*   October 2006 -Alan Berg's article "Light On Java Code" in
    [Software Testing and Performance Magazine [link broken]](http://www.stpmag.com/issues/stp-2006-10.pdf)
    discusses static code analysis using FindBugs and PMD.

*   July 2006 - Paul Duvall's article "Automation for the people: Continuous Inspection" on
    [developerWorks](http://www-128.ibm.com/developerworks/java/library/j-ap08016/index.html) discusses CPD.

*   June 2006 - Andrew Glover's article "In pursuit of code quality: Tame the chatterbox" on
    [developerWorks](http://www-128.ibm.com/developerworks/java/library/j-cq06306/index.html?ca=drs-)
    discusses PMD and JavaNCSS.

*   June 2006 - Tom Copeland's article "Static Electricity: Better Living with Static Code Analysis" in
    [Better Software](http://tomcopeland.blogs.com/juniordeveloper/2006/06/a_pmd_analysis_.html) discusses
    PMD/CPD analyses of Azureus and Columba.

*   April 2006 - John Ferguson Smart's article "PMD Squashes Code Bugs" on
    [DevX](http://www.devx.com/Java/Article/31286) discusses PMD and the Eclipse plugin. Lots of screenshots!

*   November 2005 - Mike Clark's article "Staying Out of Code Debt" on
    [StickyMinds](http://www.stickyminds.com/sitewide.asp?Function=edetail&amp;ObjectType=ART&amp;ObjectId=9860&amp;tth=DYN&amp;tt=siteemail&amp;iDyn=2)
    mentions both PMD and CPD as useful code-checking tools.

*   October 2005 - Levent Gurses' article "Improving Code Quality with PMD and Eclipse" in
    [EclipseZone](http://www.eclipsezone.com/articles/pmd/) talks about the PMD Eclipse plugin and explains many
    different facets of PMD - XPath, writing rules, the AST, all that.  Good stuff!

*   June 2005 - Amit Chaturvedi's article "Java & Static Analysis" in
    [Doctor Dobb's Journal](http://www.drdobbs.com/jvm/java-static-analysis/184406143) talks about PMD and shows a
    screenshot of the rule designer

*   March 2005 - Kirk Knoernschild's article "Benefits of the Build" in
    [Doctor Dobb's Journal](http://www.drdobbs.com/benefits-of-the-build/184415286) mentions PMD as a way
    to automate code reviews

*   February 2005 - [Java Is Well-Suited for Open-Source Projects](http://www.eweek.com/c/a/Application-Development/Java-Is-WellSuited-for-OpenSource-Projects/) -
    Peter Coffee's eWeek article on open source, Java, and PMD

*   January 2005 - [Zap bugs with PMD](http://www.ibm.com/developerworks/java/library/j-pmd/) - Elliotte Rusty
    Harold's article on installing, configuring, and running PMD

*   November 2004 - [PMD: A code analyzer for Java programmers](http://archive09.linux.com/feature/40235) - Daniel
    Rubio's article about PMD; includes some notes on XPath rules

*   June 2004 - [Code Improvement Through Cyclomatic Complexity](http://onjava.com/pub/a/onjava/2004/06/16/ccunittest.html) -
    Andrew Glover's CCM article featuring PMD

*   June 2004 - [Open Source-Perlen](http://tinyurl.com/3dgpe) - A German article on PMD in Java Magazin

*   June 2004 - [Improving Project Quality with PMD](http://jnb.ociweb.com/jnb/jnbJun2004.html) - Tom Wheeler's
    "Java News Brief", June 2004 issue

*   February 2004 - [Software Development](http://www.drdobbs.com/free-as-in-freedom/184415103) - Listed as one of
    their 'Open-Source Projects to Watch'

*   November 2003 - [JavaWorld: "Bug patrol"](http://www.javaworld.com/javaworld/jw-11-2003/jw-1121-quality.html) -
    Various code inspection tools

*   [JJGuidelines - Java and J2EE Conventions, Guidelines and Best Practices [link broken]](https://jjguidelines.dev.java.net/index.html) -
    a project sponsored by the Belgian government to codify coding practices; uses PMD as the compliance checking utility

*   June 2003 - [Software Development Times [link broken]](http://www.sdtimes.com/news/080/story15.htm) - PMD
    is embedded in QStudio.

*   May 2003 - [techrepublic.com](http://www.techrepublic.com/article/three-tools-that-make-java-code-review-painless-and-effective/5031836) -
    PMD, Checkstyle, and Jalopy

*   April 2003 - [O'Reilly OnJava.com](http://onjava.com/pub/a/onjava/2003/04/09/pmd_rules.html) - PMD custom rules

*   March 2003 - [O'Reilly OnJava.com](http://onjava.com/pub/a/onjava/2003/03/12/pmd_cpd.html) - overview of CPD

*   February 2003 - [O'Reilly OnJava.com](http://onjava.com/pub/a/onjava/2003/02/12/static_analysis.html) - overview of PMD

*   January 2003 - [Sprout](http://netbeans.org/community/articles/interviews/tom_copeland_ole-martin_fr.html) -
    interview with Ole-Martin and Tom
